package application

import (
	"os"
	"path"
	"sirlab.de/go/knyt/game"
	"sirlab.de/go/knyt/statement"
)

func (app Application) loadStatements(gm *game.Game, dirName string) error {
	files, err := os.ReadDir(dirName)
	if err != nil {
		return err
	}

	for _, dir := range files {
		if !dir.IsDir() {
			continue
		}

		userId := dir.Name()
		statementDir := path.Join(dirName, userId)
		err := app.loadUserStatements(gm, userId, statementDir)
		if err != nil {
			return err
		}
	}

	return nil
}

func (app Application) loadUserStatements(gm *game.Game, userId, dirName string) error {
	files, err := os.ReadDir(dirName)
	if err != nil {
		return err
	}

	for _, file := range files {
		fileName := path.Join(dirName, file.Name())
		statement, err := statement.NewStatementFromFile(fileName)
		if err != nil {
			return err
		}

		gm.AddStatement(userId, statement)
	}
	return nil
}
